Subject: Re: bug#67714: “guix build racket” different from “guix shellracket”

From: Simon Tournier <[email-masked]>
Date: Mon, 11 Dec 2023 13:05:42 +0100

Hi,

On ven., 08 déc. 2023 at 19:08, Ludovic Courtès <[email-masked]> wrote:

> I guess we can close if it’s not reproducible now?

Well, I reproduce the issue with my laptop using Guix 8e61e63 pulled on
Dec. 11th.  Running “guix shell” launches the ’install’ phase when “guix
build” just fetches the substitute; see below.

>From “guix shell”, the derivation builder reads:

   (apply invoke racket "/gnu/store/ajvaxayiqk7wgzxxkwvkjn5cbi313f0m-configure-layer.rkt"

And from “guix build”, the derivation builder reads:

    (apply invoke racket "/gnu/store/xgaj5m1yhyrc80jhx9djsvg4r7lgrz05-configure-layer.rkt"

Now, let checkout:

        $ ./pre-inst-env guix describe
        Git checkout:
          repository: /home/simon/src/guix/guix/
          branch: HEAD
          commit: 8e61e6351510f5665d09c6debc0584b3ed218e73

Then, it just works:

--8<---------------cut here---------------start------------->8---
$ ./pre-inst-env guix shell racket --no-grafts
The following derivation will be built:
  /gnu/store/ylwx5qdv5lqjmd476fld8gzwv5ngw01p-profile.drv

0,2 MB will be downloaded
 module-import-compiled  177KiB                                            646KiB/s 00:00 ▕██████████████████▏ 100.0%
building CA certificate bundle...
listing Emacs sub-directories...
building fonts directory...
generating GdkPixbuf loaders cache...
generating GLib schema cache...
creating GTK+ icon theme cache...
building cache files for GTK+ input methods...
building directory of Info manuals...
building XDG desktop file cache...
building XDG MIME database...
building profile with 1 package...
--8<---------------cut here---------------end--------------->8---

The profile derivation refers to the item:

    /gnu/store/ygf3aip0r2fl8mjnanwf03sxbjmdr1qj-racket-8.10.drv

which compares to:

    $ guix build racket -d --no-grafts
    /gnu/store/ygf3aip0r2fl8mjnanwf03sxbjmdr1qj-racket-8.10.drv

Hum, the bug is probably trickier than I initially thought.

Cheers,
simon

--8<---------------cut here---------------start------------->8---
$ guix shell chez-scheme racket guile --pure
substitute: updating substitutes from 'https://ci.guix.gnu.org'... 100.0%
substitute: updating substitutes from 'https://bordeaux.guix.gnu.org'... 100.0%
9,9 MB will be downloaded
 chez-scheme-9.5.8-doc  2.1MiB        763KiB/s 00:03 ▕██████████████████▏ 100.0%
 chez-scheme-9.5.8  2.4MiB            600KiB/s 00:04 ▕██████████████████▏ 100.0%
 cups-minimal-2.4.7  4.9MiB           711KiB/s 00:07 ▕██████████████████▏ 100.0%
substitute: updating substitutes from 'https://ci.guix.gnu.org'... 100.0%
5,4 MB will be downloaded
 cups-2.4.7                                  533KiB/s 00:11 | 5.5MiB transferred
substitute: updating substitutes from 'https://ci.guix.gnu.org'... 100.0%
substitute: updating substitutes from 'https://bordeaux.guix.gnu.org'... 100.0%
The following derivations will be built:
  /gnu/store/5wkp5xwbrn4qqyrnfk9v9vzaiahk3h4k-racket-8.10.drv
  /gnu/store/ll9dxprspbjm2phqpbz58imgpiy9rbnr-racket-minimal-8.10.drv

26,6 MB will be downloaded
 glu-9.0.2  265KiB                    2.0MiB/s 00:00 ▕██████████████████▏ 100.0%
 racket-vm-cs-8.10  25.1MiB           450KiB/s 00:57 ▕██████████████████▏ 100.0%
building /gnu/store/ll9dxprspbjm2phqpbz58imgpiy9rbnr-racket-minimal-8.10.drv...
building /gnu/store/5wkp5xwbrn4qqyrnfk9v9vzaiahk3h4k-racket-8.10.drv...
/ 'install' phase  C-c C-c

$ guix build racket
substitute: updating substitutes from 'https://ci.guix.gnu.org'... 100.0%
125,7 MB will be downloaded:
  /gnu/store/cbm1pbg9zgpj6wg9m0l0xjz72gi6cp8f-racket-minimal-8.10
  /gnu/store/4bwp8syfwdlkzxbhx52i6l9yjfp1znkh-racket-8.10
substituting /gnu/store/cbm1pbg9zgpj6wg9m0l0xjz72gi6cp8f-racket-minimal-8.10...
downloading from https://ci.guix.gnu.org/nar/lzip/cbm1pbg9zgpj6wg9m0l0xjz72gi6cp8f-racket-minimal-8.10 ...
 racket-minimal-8.10  11KiB           1.5MiB/s 00:00 ▕██████████████████▏ 100.0%

substituting /gnu/store/4bwp8syfwdlkzxbhx52i6l9yjfp1znkh-racket-8.10...
downloading from https://ci.guix.gnu.org/nar/zstd/4bwp8syfwdlkzxbhx52i6l9yjfp1znkh-racket-8.10 ...
 racket-8.10  132.1MiB                440KiB/s 05:08 ▕██████████████████▏ 100.0%

The following grafts will be made:
   /gnu/store/1cdi64z69h2fq1sdhzwqmhjqdir4yd90-racket-8.10.drv
   /gnu/store/8w5mgd0s4lrjh541kq36k9i8fq2nsy35-glu-9.0.2.drv
   /gnu/store/bg0ajbgqbvc8sxgj48grcqnmy4iq1kyr-racket-vm-cs-8.10.drv
   /gnu/store/yknjcsgp0asimg2ik99d42q3xspsds96-lz4-1.9.3.drv
   /gnu/store/i2p2k7v7l0cv6wrb7iafb9mhzccc7lj7-gtk+-3.24.37.drv
   /gnu/store/0c6cyncz0g5yyx0rs63i1ymg6s3pphsw-cups-2.4.7.drv
   /gnu/store/0qmw4vj1by85bmdj1l35iv9122pnnzjr-cups-filters-1.28.15.drv
   /gnu/store/8vvbr8khaqg9v8in2b3g09y3yrxx6la7-cups-minimal-2.4.7.drv
   /gnu/store/l5sjy9jn0ydlvgcsdwvndzp9jz2v0kcz-ghostscript-with-cups-9.56.1.drv
   /gnu/store/vd49ihqmrf5jnmnmv6n5c8gyqdc30d2f-racket-minimal-8.10.drv
applying 3 grafts for glu-9.0.2 ...
grafting '/gnu/store/p6h3qkzh7azp0djcwhks6cr3z7jj3cmw-glu-9.0.2' -> '/gnu/store/n7df20wiwjmqj96cxrdgvydydd1z7k92-glu-9.0.2'...
successfully built /gnu/store/8w5mgd0s4lrjh541kq36k9i8fq2nsy35-glu-9.0.2.drv
applying 12 grafts for cups-minimal-2.4.7 ...
grafting '/gnu/store/jnbdnn8x1hr4smlxx53migv0bnzsc9m9-cups-minimal-2.4.7' -> '/gnu/store/97d4pyag67py10gzlj0j27wfc6sh862y-cups-minimal-2.4.7'...
successfully built /gnu/store/8vvbr8khaqg9v8in2b3g09y3yrxx6la7-cups-minimal-2.4.7.drv
applying 2 grafts for lz4-1.9.3 ...
grafting '/gnu/store/qym8x2bhabj79cqx51jihlz0hd7nkch0-lz4-1.9.3' -> '/gnu/store/h2i1rj2nn7hada0dhsqc5pm93343zydm-lz4-1.9.3'...
successfully built /gnu/store/yknjcsgp0asimg2ik99d42q3xspsds96-lz4-1.9.3.drv
applying 23 grafts for ghostscript-with-cups-9.56.1 ...
grafting '/gnu/store/l546pfngkkk0xb84j2svrvax3h4rcsdx-ghostscript-with-cups-9.56.1-doc' -> '/gnu/store/kvxbxpk2cg6y7lmr0aiq4gbxqq6nz80y-ghostscript-with-cups-9.56.1-doc'...
grafting '/gnu/store/1fv5dv221zcp1080p3kdxfsd6b10nllj-ghostscript-with-cups-9.56.1' -> '/gnu/store/h2jmnszansk01rsa40h7ws45mr89blrv-ghostscript-with-cups-9.56.1'...
successfully built /gnu/store/l5sjy9jn0ydlvgcsdwvndzp9jz2v0kcz-ghostscript-with-cups-9.56.1.drv
applying 5 grafts for racket-vm-cs-8.10 ...
grafting '/gnu/store/apxq5vmqqxlcxmqdndnwb6cshwnvm6yw-racket-vm-cs-8.10' -> '/gnu/store/nrzsbqijrphs9j5spy171rq0h6j5ngg1-racket-vm-cs-8.10'...
successfully built /gnu/store/bg0ajbgqbvc8sxgj48grcqnmy4iq1kyr-racket-vm-cs-8.10.drv
applying 29 grafts for cups-filters-1.28.15 ...
grafting '/gnu/store/7d64r375qwsvfqyx235p5zgh6dc133bj-cups-filters-1.28.15' -> '/gnu/store/p12dwhnqwa861lagmzvv2nnpqyxb4kxv-cups-filters-1.28.15'...
successfully built /gnu/store/0qmw4vj1by85bmdj1l35iv9122pnnzjr-cups-filters-1.28.15.drv
applying 9 grafts for racket-minimal-8.10 ...
grafting '/gnu/store/cbm1pbg9zgpj6wg9m0l0xjz72gi6cp8f-racket-minimal-8.10' -> '/gnu/store/h1s4211ym2xzfffxkrzsqx7qjyhwgb2y-racket-minimal-8.10'...
successfully built /gnu/store/vd49ihqmrf5jnmnmv6n5c8gyqdc30d2f-racket-minimal-8.10.drv
applying 16 grafts for cups-2.4.7 ...
grafting '/gnu/store/m3i72ximavwa480l4piv9zjfha4v639p-cups-2.4.7' -> '/gnu/store/414fi9w41yg776vi2pxam0x64xvwz8cm-cups-2.4.7'...
successfully built /gnu/store/0c6cyncz0g5yyx0rs63i1ymg6s3pphsw-cups-2.4.7.drv
applying 28 grafts for gtk+-3.24.37 ...
grafting '/gnu/store/6p5snzv6mkwkxpyr9cf1idi93lj5m8np-gtk+-3.24.37' -> '/gnu/store/bxcrh60vx2xg86p2lvddkyhxxxypk8p1-gtk+-3.24.37'...
successfully built /gnu/store/i2p2k7v7l0cv6wrb7iafb9mhzccc7lj7-gtk+-3.24.37.drv
applying 24 grafts for racket-8.10 ...
grafting '/gnu/store/4bwp8syfwdlkzxbhx52i6l9yjfp1znkh-racket-8.10' -> '/gnu/store/am5ilghrzkcyxpmbxdacdbijygvvbglp-racket-8.10'...
successfully built /gnu/store/1cdi64z69h2fq1sdhzwqmhjqdir4yd90-racket-8.10.drv
/gnu/store/am5ilghrzkcyxpmbxdacdbijygvvbglp-racket-8.10
--8<---------------cut here---------------end--------------->8---